unit Main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Wingpnt, StdCtrls, Spin, ExtCtrls, Polygon,
  AbWinG, Dib, Buttons, Sprite, DIBSprit;

type

  TfrmMain = class(TForm)
    WinGPaintBox1: TWinGPaintBox;
    Timer1: TTimer;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    panelNum: TPanel;
    Button4: TButton;
    Button5: TButton;
    dibBoard: TDIB;
    dibMech: TDIB;
    Edit1: TEdit;
    Panel1: TPanel;
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure WinGPaintBox1MouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
  private
    nNum: word;
    nSize: longint;
    bTime: boolean;
    nCol: byte;
  public
    constructor Create( AOwner: TComponent ); override;
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}

constructor TfrmMain.Create( AOwner: TComponent );
begin
  inherited Create( AOwner );
  Randomize;
  nNum := 0;
  nCol := 0;
end;

procedure TfrmMain.Button1Click(Sender: TObject);
var
  s: TSquareSprite;
begin
  s := TSquareSprite.CreateColor( nCol );
  Inc( nCol );
  s.Destination := ( Point( 100, 100 ) );
  s.Speed := 2;
  s.Spin := rotClockwise;
  s.SpinSpeed := 10;
  s.RegisterSprite( WinGPaintBox1 );
  Inc( nNum );
  panelNum.Caption := IntToStr( nNum );
end;

procedure TfrmMain.Timer1Timer(Sender: TObject);
var
  i: integer;
begin
  if not bTime then
     begin
        bTime := TRUE;
        WinGPaintBox1.Paint;
        bTime := FALSE;
     end;
end;

procedure TfrmMain.Button2Click(Sender: TObject);
var
  i: integer;
begin
  for i := 0 to WinGPaintBox1.lstSprites.Count - 1 do
     with TSprite( WinGPaintBox1.lstSprites[i] ) do
        begin
           Speed := ( Random( 30 ) );
           Destination := ( Point( Random( WinGPaintBox1.PhysicalWidth ), Random( WinGPaintBox1.PhysicalHeight ) ) );
           if TSprite( WinGPaintBox1.lstSprites[i] ) is TSquareSprite then
              with TSquareSprite( WinGPaintBox1.lstSprites[i] ) do
                 begin
                    SpinSpeed := Random( 20 );
                    case Random( 3 ) of
                       0:
                          Spin := rotNone;
                       1:
                          Spin := rotClockwise;
                       2:
                          Spin := rotCounterClockwise;
                    end;
                 end;
        end;
end;

procedure TfrmMain.Button3Click(Sender: TObject);
begin
  frmAboutWinG := TfrmAboutWinG.Create( self );
  frmAboutWinG.ShowModal;
  frmAboutWinG.Free;
end;

procedure TfrmMain.Button4Click(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.Button5Click(Sender: TObject);
var
  d: TDIBSprite;
begin
  d := TDIBSprite.CreateFromDIB( dibMech );
  d.Destination := ( Point( 100, 100 ) );
  d.Speed := 2;
  d.RegisterSprite( WinGPaintBox1 );
  Inc( nNum );
  panelNum.Caption := IntToStr( nNum );
end;

(*********************************************
Size the form to the client area.  Note that
the PhysicalWidth and PhysicalHeight remain
at 640x480 after this code is executed.
*********************************************)
procedure TfrmMain.Button7Click(Sender: TObject);
begin
  timer1.Enabled := FALSE;
  Application.ProcessMessages;
  dibBoard.LoadFromFile( 'BGFLAT2.BMP' );
  timer1.Enabled := TRUE;
end;

procedure TfrmMain.Button6Click(Sender: TObject);
begin
  timer1.Enabled := FALSE;
  Application.ProcessMessages;
  dibBoard.LoadFromFile( 'BGFLAT.BMP' );
  timer1.Enabled := TRUE;
end;

procedure TfrmMain.FormResize(Sender: TObject);
begin
  WinGPaintBox1.Width := ClientWidth;
  WinGPaintBox1.Height := ClientHeight;
end;

(*********************************************
Draw a line for testing.
*********************************************)
procedure TfrmMain.WinGPaintBox1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  edit1.Text := IntToStr( X ) + ',' + IntToStr( Y );
end;

end.
